mod Ex10 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  10. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 21.4.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane termom. Zadanie sa 
  sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex10*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Numeric Terms.  \end 

rem 
  \para \bf  Arithmetization of numeric terms.  \end 

fun Vt 'Tex_f1_nt_vt'
  Vt(i) = 0,i

fun Ct 'Tex_f1_nt_ct'
  Ct(n) = 1,n

fun/2 At 'Tex_f2_nt_at'
  At(t1,t2) = 2,t1,t2

fun/2 Mt 'Tex_f2_nt_mt'
  Mt(t1,t2) = 3,t1,t2

pred Term 
  Term Vt(i) <- N(i)
  Term Ct(n) <- N(n)
  Term At(t1,t2) <- Term(t1) & Term(t2)
  Term Mt(t1,t2) <- Term(t1) & Term(t2)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Term(t) -> 
    \e i(t = Vt(i) & N(i)) \/ \e n(t = Ct(n) & N(n)) \/ 
    \e t1\e t2 t = At(t1,t2) \/ \e t1\e t2 t = Mt(t1,t2)
  \end

thm Case_analysis_on_numeric_terms
  Term(t) -> 
  \e i(t = Vt(i) & N(i)) \/ \e n(t = Ct(n) & N(n)) \/ 
  \e t1\e t2 t = At(t1,t2) \/ \e t1\e t2 t = Mt(t1,t2)

rem 
  \para \bf  [CL] Case analysis on numeric terms.  \end Syntax: 
  \items 
   \item \para the command \it  case  \end \ft Term \end \it  ;  \end 
         \ft Tex0_tau \end invokes case analysis on the numeric term 
         \ft Tex0_tau \end ( \ft Term \end-case analysis for short). 
  \end
  \para See also the theorem \it  Case_analysis_on_numeric_terms  \end. 

theory Admissibility_of_structural_induction_on_numeric_terms

pred A 'Tex_p1_phi_subst'

axiom Assumption_vt
  N(i) -> A Vt(i)

axiom Assumption_ct
  N(n) -> A Ct(n)

axiom Assumption_at
  A(t1) & A(t2) -> A At(t1,t2)

axiom Assumption_mt
  A(t1) & A(t2) -> A Mt(t1,t2)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Term(t) -> A(t)
  \end
  \para \it  [CL] Hint.  \end Prove the claim by measure induction with measure 
  \ft |t| \end. 

thm Conclusion
  Term(t) -> A(t)

end theory Admissibility_of_structural_induction_on_numeric_terms

theory Admissibility_of_structural_induction_on_numeric_terms_strong_form

pred A 'Tex_p1_phi_subst'

axiom Assumption_vt
  N(i) -> A Vt(i)

axiom Assumption_ct
  N(n) -> A Ct(n)

axiom Assumption_at
  Term(t1) & A(t1) & Term(t2) & A(t2) -> A At(t1,t2)

axiom Assumption_mt
  Term(t1) & A(t1) & Term(t2) & A(t2) -> A Mt(t1,t2)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Term(t) -> A(t)
  \end
  \para \it  [CL] Hint.  \end Prove the claim by measure induction with measure 
  \ft |t| \end. 

thm Conclusion
  Term(t) -> A(t)

end theory Admissibility_of_structural_induction_on_numeric_terms_strong_form

rem 
  \para \bf  [CL] Structural induction on numeric terms.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft Term \end \it  ;  \end \ft t \end 
         invokes structural induction on the term \ft t \end with the induction 
         formula \ft Tex2_bappl1(Tex0_phi,t) \end, where 
         \ft Tex2_bappl1(Tex0_phi,t) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft Term \end \it  ;  \end \ft t \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         term \ft t \end with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,t,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,t,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Term \end \it  ;  \end \ft t \end 
         invokes structural induction on the term \ft t \end (strong form) with 
         the induction formula \ft Tex2_bappl1(Tex0_phi,t) \end, where 
         \ft Tex2_bappl1(Tex0_phi,t) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Term \end \it  ;  \end \ft t \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         term \ft t \end (strong form) with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,t,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,t,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Size of numeric terms.  \end 

fun Sz 'Tex_f1_nt_sz'
  Sz Vt(i) = 1
  Sz Ct(n) = 1
  Sz At(t1,t2) = Sz(t1)+Sz(t2)+1
  Sz Mt(t1,t2) = Sz(t1)+Sz(t2)+1

rem 
  \para \bf  Denotation of numeric terms.  \end 

fun/2 Den 'Tex_f2_nt_den'
  Den(t,v) = Foo

rem 
  \para \bf  Free variables.  \end 

fun Fv 'Tex_f1_nt_fv'
  Fv(t) = Foo

rem 
  \para \bf  Coincidence of assignments.  \end 

pred/3 Equiv 'Tex_p3_nt_equiv'
  Equiv(v1,v2,is) <-> \a i(i in is -> Sub(v1,i) = Sub(v2,i))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Equiv_den_term
    Term(t) & Equiv(v1,v2,Fv(t)) -> Den(t,v1) = Den(t,v2)
  \end

thm Equiv_den_term
  Term(t) & Equiv(v1,v2,Fv(t)) -> Den(t,v1) = Den(t,v2)
proof  proved.

rem 
  \para \bf  Postfix machine.  \end 

rem 
  \para \it  Instructions.  \end 

fun Vi 'Tex_f1_nt_vi'
  Vi(i) = 0,i

fun Ci 'Tex_f1_nt_ci'
  Ci(n) = 1,n

fun/0 Ai 'Tex_f0_nt_ai'
  Ai = 2,0

fun/0 Mi 'Tex_f0_nt_mi'
  Mi = 3,0

pred Instr 
  Instr Vi(i) <- N(i)
  Instr Ci(n) <- N(n)
  Instr(Ai)
  Instr(Mi)

rem 
  \para \it  Programs.  \end 

pred Program 
  Program(0)
  Program(i,p) <- Instr(i) & Program(p)

rem 
  \para \it  Compilation.  \end 

fun Cmp 
  Cmp(t) = Foo

rem 
  \para \it  Evaluation.  \end 

fun/3 Run 
  Run(p,v,s) = Foo

fun/2 Eval 
  Eval(p,v) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Cmp_program
    Term(t) -> Program Cmp(t)
  \end

thm Cmp_program
  Term(t) -> Program Cmp(t)
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Eval_term
    Term(t) -> Eval(Cmp(t),v) = Den(t,v)
  \end

thm Eval_term
  Term(t) -> Eval(Cmp(t),v) = Den(t,v)
proof  proved.

rem 
  \para \bf  Section. Exercises.  \end 

rem 
  \para \bf  Left associative terms.  \end 

pred Lassoc 
  Lassoc Vt(i)
  Lassoc Ct(n)
  Lassoc At(t,Vt(i)) <- Lassoc(t)
  Lassoc At(t,Ct(n)) <- Lassoc(t)
  Lassoc At(t,Mt(t1,t2)) <- Lassoc(t)
  Lassoc Mt(t1,t2)

rem 
  \para \bf  Translation of numeric terms into left associative terms.  \end 

fun T2lat 'Tex_f1_f'
  T2lat(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq T2lat_term
    Term(t) -> Term T2lat(t)
  \end
  \eq T2lat_lassoc
    Term(t) -> Lassoc T2lat(t)
  \end
  \eq T2lat_den
    Term(t) -> Den(T2lat(t),v) = Den(t,v)
  \end
  \eq T2lat_sz
    Term(t) -> Sz T2lat(t) = Sz(t)
  \end

thm T2lat_term
  Term(t) -> Term T2lat(t)

thm T2lat_lassoc
  Term(t) -> Lassoc T2lat(t)

thm T2lat_den
  Term(t) -> Den(T2lat(t),v) = Den(t,v)
proof  proved.

thm T2lat_sz
  Term(t) -> Sz T2lat(t) = Sz(t)

