mod Maux logic: 'cl'

incl Mtex

rem 
  \para \bf  Lists.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

thm L_zero
  L(x) = 0 <-> x = 0
proof 
 case Ln; x @ 0; v,w
  proved
  proved..

thm L_conc
  L(x++y) = L(x)+L(y)
proof 
 ind Ln; x @ 0; v,w
  proved
  proved..

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

fun/2 Drop 
  Drop(0,x) = x
  Drop(n+1,v,w) = Drop(n,w)

thm Drop_l_conc
  Drop(L(x),x++y) = y
proof 
 ind Ln; x @ 0; v,w
  proved
  proved..

rem 
  \para \bf  Sublists.  \end 

pred/2 Subl 'Tex2_subset'
  Subl(x,y) <-> \a z(z in x -> z in y)

thm Subl_refl
  Subl(x,x)
proof 
 exp Subl; x,x proved..

thm Subl_trans
  Subl(x,y) & Subl(y,z) -> Subl(x,z)
proof 
 exp Subl; x,y
  exp Subl; y,z
   exp Subl; x,z
    eigen* \a z1(z1 in x -> z1 in z).0; a
     inst \a z1(z1 in x -> z1 in y); a
      inst \a z1(z1 in y -> z1 in z); a proved.......

thm Subl_zero_left
  Subl(0,y)
proof 
 exp Subl; 0,y proved..

thm Subl_pair_left
  Subl((v,w),y) <-> v in y & Subl(w,y)
proof 
 split* Subl((v,w),y) <-> v in y & Subl(w,y).2,(1,0,4,0,0,0),0
  exp Subl; (v,w),y
   inst \a z(z = v \/ z in w -> z in y).1,(4,0,0),0; v proved..
  exp Subl; w,y
   exp Subl; (v,w),y
    flatten \a z(z = v \/ z in w -> z in y).1,(4,1,0),0 proved...
  exp Subl; (v,w),y
   split* \a z(z = v \/ z in w -> z in y).1,(4,0,0,0),0
    eigen* \a z(z = v -> z in y).0; z proved.
    exp Subl; w,y proved.....

thm Subl_conc_left
  Subl(x1++x2,y) <-> Subl(x1,y) & Subl(x2,y)
proof 
 ind Ln; x1 @ 0; v,w
  use Subl_zero_left; y proved.
  use Subl_pair_left.0; v; w; y
   use Subl_pair_left.0; v; w++x2; y proved....

